X-Git-Url: https://git.rohieb.name/openwrt.git/blobdiff_plain/70f06b0258b9edcf81246cca3480643082702860..33f858ee205cf55679ddce8cad468c7bb178bd67:/package/dnsmasq/files/dnsmasq.init

diff --git a/package/dnsmasq/files/dnsmasq.init b/package/dnsmasq/files/dnsmasq.init
index 49291a5c8..a0e893c5f 100644
--- a/package/dnsmasq/files/dnsmasq.init
+++ b/package/dnsmasq/files/dnsmasq.init
@@ -23,8 +23,8 @@ append_bool() {
 	local option="$2"
 	local value="$3"
 	local _loctmp
-	config_get_bool _loctmp "$section" "$option"
-	[ "$_loctmp" -gt 0 ] && append args "$value"
+	config_get_bool _loctmp "$section" "$option" 0
+	[ $_loctmp -gt 0 ] && append args "$value"
 }
 
 append_parm() {
@@ -42,17 +42,23 @@ append_server() {
 }
 
 append_interface() {
-	append args "-i $1"
+	local ifname=$(uci_get_state network "$1" ifname "$1")
+	append args "-i $ifname"
 }
 
 append_notinterface() {
-	append args "-I $1"
+	local ifname=$(uci_get_state network "$1" ifname "$1")
+	append args "-I $ifname"
 }
 
 append_addnhosts() {
 	append args "-H $1"
 }
 
+append_bogusnxdomain() {
+       append args "-B $1"
+}
+
 dnsmasq() {
 	local cfg="$1"
 	append_bool "$cfg" authoritative "-K"
@@ -72,6 +78,8 @@ dnsmasq() {
 	append_bool "$cfg" enable_tftp "--enable-tftp"
 	append_bool "$cfg" nonwildcard "-z"
 
+	append_parm "$cfg" dhcpscript "-6"
+	append_parm "$cfg" cachesize "-c"
 	append_parm "$cfg" dnsforwardmax "-0"
 	append_parm "$cfg" port "-p"
 	append_parm "$cfg" ednspacket_max "-P"
@@ -83,6 +91,7 @@ dnsmasq() {
 	config_list_foreach "$cfg" "interface" append_interface
 	config_list_foreach "$cfg" "notinterface" append_notinterface
 	config_list_foreach "$cfg" "addnhosts" append_addnhosts
+	config_list_foreach "$cfg" "bogusnxdomain" append_bogusnxdomain
 	append_parm "$cfg" "leasefile" "-l"
 	append_parm "$cfg" "resolvfile" "-r"
 	append_parm "$cfg" "tftp_root" "--tftp-root"
@@ -91,10 +100,10 @@ dnsmasq() {
 	config_get DOMAIN "$cfg" domain
 
 	config_get_bool readethers "$cfg" readethers
-	[ "$readethers" = "1" ] && [ -e "/etc/ethers" ] || touch /etc/ethers
+	[ "$readethers" = "1" -a \! -e "/etc/ethers" ] && touch /etc/ethers
 
 	config_get leasefile $cfg leasefile
-	[ -e "$leasefile" ] || touch "$leasefile"
+	[ -n "$leasefile" -a \! -e "$leasefile" ] && touch "$leasefile"
 	config_get_bool cachelocal "$cfg" cachelocal 1
 
 	config_get hostsfile "$cfg" dhcphostsfile
@@ -197,20 +206,19 @@ dhcp_vendorclass_add() {
 dhcp_host_add() {
 	local cfg="$1"
 
-	config_get name "$cfg" name
-
 	config_get networkid "$cfg" networkid
 	[ -n "$networkid" ] && dhcp_option_add "$cfg" "$networkid"
 
+	config_get name "$cfg" name
 	config_get ip "$cfg" ip
-	[ -n "$ip" ] || return 0
+	[ -n "$ip" ] || [ -n "$name" ] || return 0
 
 	macs=""
 	config_get mac "$cfg" mac
 	for m in $mac; do append macs "$m" ","; done
 	[ -n "$macs" ] || return 0
 
-	append args "--dhcp-host=$macs,${networkid:+net:$networkid,}$ip${name:+,$name}"
+	append args "--dhcp-host=$macs${networkid:+,net:$networkid}${ip:+,$ip}${name:+,$name}"
 }
 
 dhcp_mac_add() {
@@ -263,7 +271,7 @@ dhcp_add() {
 		DNS_SERVERS="$DNS_SERVERS $dnsserver"
 	}
 
-	append_bool "$cfg" ignore "-2 '$ifname'" && return 0
+	append_bool "$cfg" ignore "-2 $ifname" && return 0
 
 	config_get proto "$net" proto
 	[ static = "$proto" ] || return 0
@@ -274,8 +282,13 @@ dhcp_add() {
 
 	#check for an already active dhcp server on the interface, unless 'force' is set
 	config_get_bool force "$cfg" force 0
-	[ "$force" -gt 0 ] || {
-		udhcpc -n -q -s /bin/true -t 1 -i $ifname >&- && return 0
+	[ $force -gt 0 ] || {
+		udhcpc -n -q -s /bin/true -t 1 -i $ifname >&- && {
+			logger -t dnsmasq \
+				"found already running DHCP-server on interface '$ifname'" \
+				"refusing to start, use 'option force 1' to override"
+			return 0
+		}
 	}
 
 	config_get start "$cfg" start
@@ -287,6 +300,7 @@ dhcp_add() {
 	leasetime="${leasetime:-12h}"
 	start="$(dhcp_calc "${start:-100}")"
 	limit="${limit:-150}"
+	[ "$limit" -gt 0 ] && limit=$((limit-1))
 	eval "$(ipcalc.sh $ipaddr $netmask $start $limit)"
 	if [ "$dynamicdhcp" = "0" ]; then END="static"; fi
 	append args "--dhcp-range=$networkid,$START,$END,$NETMASK,$leasetime${options:+ $options}"
@@ -384,6 +398,6 @@ stop() {
 		rm -f /tmp/resolv.conf
 		ln -s /tmp/resolv.conf.auto /tmp/resolv.conf
 	}
-	killall dnsmasq
+	service_kill dnsmasq /var/run/dnsmasq.pid
 	return 0
 }